package aaa.bbb;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.StateListDrawable;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.TabHost;
import android.widget.TabWidget;

public class ExtendedTabHost extends TabHost{
	public ExtendedTabHost(Context context) {
		super(context, null);
		initializeTabWidget(context);
		
	}
	private void initializeTabWidget(Context context) {
		TabWidget tw = new TabWidget(context);
		LinearLayout ll = new LinearLayout(context);
		int pad = dipToCurrent(5);
		ll.setPadding(pad, pad, pad, pad);
		ll.setOrientation(LinearLayout.VERTICAL);
		tw.setId(android.R.id.tabs);
		ll.addView(tw, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
		FrameLayout fl = new FrameLayout(context);
		fl.setId(android.R.id.tabcontent);
		fl.setPadding(pad, pad, pad, pad);
		ll.addView(fl, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
		this.addView(ll,new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
		this.setup();
	}
	public void extendedAddTab(CharSequence title, Bitmap defaultBitmap, Bitmap selectedBitmap, View view) {
		MyContentFactory m = new MyContentFactory(view);
		TabSpec ts = this.newTabSpec("");
		ts.setContent(m);
		if (defaultBitmap != null && selectedBitmap != null) {
			anywheresoftware.b4a.objects.drawable.BitmapDrawable bd1, bd2;
			bd1 = new anywheresoftware.b4a.objects.drawable.BitmapDrawable();
			bd1.Initialize(defaultBitmap);
			bd2 = new anywheresoftware.b4a.objects.drawable.BitmapDrawable();
			bd2.Initialize(selectedBitmap);
			StateListDrawable sd = new StateListDrawable();
			sd.addState(new int[] {anywheresoftware.b4a.objects.drawable.StateListDrawable.State_Selected},
					bd2.getObject());
			sd.addState(new int[0], bd1.getObject());
			ts.setIndicator(title, sd);
		}
		else {
			ts.setIndicator(title);
		}
		this.addTab(ts);
	}
	private int dipToCurrent(int length) {
		return (int) (length * getResources().getDisplayMetrics().density);
	}
	private static class MyContentFactory implements TabHost.TabContentFactory {
		private View view;
		public MyContentFactory(View view) {
			this.view = view;
		}
		public View createTabContent(String tag) {
			return view;
		}
		
	}
}
